﻿Imports System.IO
Public Class Form1
    Public Nc As Integer = 600                                     'number of cells  600
    Public HVC(Nc) As HuVECII                                 'define cell number
    Public cellNo As Integer                                         'sequential No. of a cell within the one-dimensional array

    '********** prepared pens **********
    Public gradient5 As New Graph2018.GradientPen(5)         '(pen width)
    Public gradient4 As New Graph2018.GradientPen(4)         '(pen width)
    Public gradient3 As New Graph2018.GradientPen(3)         '(pen width)
    Public gradient2 As New Graph2018.GradientPen(2)         '(pen width)
    Public gradient1 As New Graph2018.GradientPen(1)         '(pen width)

    '********** Graph names **********
    Dim graph2D_Vo As Graph2018
    Dim graphVoGradient As Graph2018
    Dim graphProfileVo As Graph2018                'Calibration of Vo in mV
    Dim graphProfileCurrent As Graph2018       'profile of IK1 and IKr
    Dim graphTimeCourseVm As Graph2018                    'time course of Vm in selected Cell No.
    Dim graphprofileVm As Graph2018               ' profile of Vm along the cell allay
    Dim graphProfilepO As Graph2018                'Calibration of Vo in mV
    'Dim graphIcapIo As Graph2018
    '********** Graph parameters **********

    Dim MinX1 As Double = 0                       'Graph2DVm
    Dim MaxX1 As Double = Nc
    Dim IntervalX1 As Double = 50

    Dim MinY1 As Double = 0                         'graph2DVm
    Dim MaxY1 As Double = 400
    Dim IntervalY1 As Double = 50

    Dim MinX2 As Double = 0                         'graphVm    sweepTime
    Dim MaxX2 As Double = 5000
    Dim IntervalX2 As Double = 500

    Dim MinY2 As Double = -100                  'mV, Vm
    Dim MaxY2 As Double = 40
    Dim IntervalY2 As Double = 10

    Dim MinY4 As Double = -20                     'uV, Vo
    Dim MaxY4 As Double = 20
    Dim IntervalY4 As Double = 5

    Dim MinY5 As Double = -1                  'pA, current
    Dim MaxY5 As Double = 2
    Dim IntervalY5 As Double = 0.5

    Dim MinX6 As Double = -30
    Dim MaxX6 As Double = 30
    Dim IntervalX6 As Double = 10

    Dim MinY6 As Double = 0
    Dim MaxY6 As Double = 2
    Dim IntervalY6 As Double = 1

    Dim MinX7 As Double = 300                       'Graph2DVm
    Dim MaxX7 As Double = 500
    Dim IntervalX7 As Double = 50

    Dim MinY8 As Double = 0
    Dim MaxY8 As Double = 0.4
    Dim IntervalY8 As Double = 0.05

    '********** File to hold time variables **********
    Dim CsvFileName1 As String = "CsvCellModel.csv"
    Dim names1() As String = New String() {"Vm", "Vo", "Vi", "TnChCa", "CaMCa", "bufferSRCa", "Lb_jnc", "Lb_iz", "Hb_jnc", "Hb_iz", "Nai",
            "Ki", "Catot_jnc", "Catot_iz", "Catot_blk", "Ca_SRup", "Catot_SRrl", "O_TM", "I2_TM", "Is_TM", "O_LSM", "I1_LSM",
            "I2_LSM", "Is_LSM", "Yco_iz", "Yoc_iz", "Yoo_iz", "Yco_blk", "Yoc_blk", "Yoo_blk", "Yooo", "Yooc", "Yooi", "Ycoo", "Ycoc", "Ycoi",
            "Ycco", "Yccc", "Yoco", "Yocc", "Yoci", "y1_IKr", "y2_IKr", "y3_IKr", "Ov_IKs", "C2IKs_iz", "OcIKs_iz", "C2IKs_blk", "OcIKs_blk", "y1_IKto",
            "y2_IKto", "Pbspm", "E1NCX_iz", "I1NCX_iz", "I2NCX_iz", "E1NCX_blk", "I1NCX_blk",
            "I2NCX_blk", "P1_6_NaK", "P7_NaK", "P8_13_NaK", "halfSL", "Fb", "Fp",
            "TSCa3", "TSCa3W", "TSCa3S", "TSS", ".TSW", "hw", "hp",
            "ATPt_cyt", "ADPt_cyt", "Pi_cyt", "PCr_cyt", "ATPt_mit", "Pi_mit", "NADH_mit",
            "H_mit", "K_mit", "UQr_mit", "ctCrd_mit", "dpsi"}
    Dim FileName As String = "HVCarray.csv"

    '********** Time step **********
    Public MaxRepeat As Double = 3                    'Number of repeat the sweeps
    Public Nstretch As Double
    Dim chartTime As Double = 0
    Dim sweepTime As Double = 0                         'msec   time for each sweep
    Dim stretchTime As Double = 0                    'duration of graph2D_vo

    Public dt As Double = 0.07   '0.02   0.07              'time interval for the time-integration by the Euler Method

    Dim TtoPlotProfile As Double                            'msec timing for plot the point
    Dim maxTtoPlotProfile As Double = dt * 2           'plot every 0.5 ms

    Dim TtoPlotVm As Double
    Dim maxTtoPlotVm As Double = dt * 40          'plot every 0.8 ms

    Dim TtoPlot2DVo As Double
    Dim maxTtoPlot2DVo As Double = dt * 20           'plot every 1.6 ms

    '********** Injection current **********
    Public Samplitude As Double           'pA     current amplitude 
    Public Iinject As Double                    'pA / pF   current injection

    Public ItestOn As Double = 10            'ms, start time of external stimulation
    Public ItestOff As Double = 100

    Public measOn As Double = 1350     'ms, time interval for measurement of the propagation rate
    Public measOff As Double = 1500

    '********** Electrocardiogram Average **********
    Dim pointA As Integer            'location of - input of the amplifier
    Dim pointB As Integer            'location of + input of the amplifier
    Dim pointC As Integer             'location of + input of the amplifier

    Dim CellBorder As Double                              'last No of endo-type cell

    'Dim record As Double = 200
    Dim ExitDo As Boolean = False
    Dim FirstDefinition As Boolean = True



    '********Liner Solver 2018/08/17**********
    Dim ainv(Nc, Nc) As Double
    Dim a(Nc, Nc) As Double
    Dim b(Nc) As Double

    '***********  Cell array **************************
    Public leftCross As Double              'left cross of the rising phase
    Public rightCross As Double              'right cross of the rising phase
    'Public LData(1000, 2) As Double        'ms, leftCross, rightCross
    Public crossD(20000, 2) As Double        'ms, leftCross, rightCross
    Public Ndata As Long = 0                     'number of data points

    Dim valueA As Double
    Dim valueB As Double
    Dim halfArray As Double = Nc / 2

    Dim countbalance As Long = 0
    Public adr As Long = 0
    Public LsumRate As Double = 0
    Public RsumRate As Double = 0
    Public Lrate(80000) As Double
    Public Rrate(80000) As Double
    Dim Interrupt As Long
    Dim Repeat As Double = 0

    Private Sub ButtonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStart.Click
        ButtonStart.Visible = False               'make unvisible
        Dim appPath As String = System.Reflection.Assembly.GetExecutingAssembly().Location  'Directory of the program used
        txtDir.Text = appPath                   'Print the whole directory to indicate which program is used
        '**************************************************************************************************************

        If FirstDefinition = True Then
            DefineGraph()                       'create instances of graph
            instanceCell()                        'create instances of cell

            If chkDefault.Checked Then        'default Start
                For i As Integer = 1 To Nc
                    HVC(i).DefaultValues()       'default Start to ensure safety start
                Next i
            Else                                                'start with the values in the CSV file
                CSVRW.ReadCSV(CsvFileName1, HVC, names1)      'get initial values of variables for the numerical integration from the CSV file
            End If

            ClearAllgraphs()           'prepare all graphs
            DrawAxes()                    'prepare all graphs 
            PlotVoColorCode()         'calbration for the color code

            FirstDefinition = False                    'to avoid repetitive Definitions
        End If                            '************** End of the FirstDefinition *********************************

        ReadForm()                              'protocol of experiments; Stimulus strength, current amplitude  & Sweeptime max  etc.
        PrepareMatrices()                     'create matrices for determining Vo & Vi the one dimensional Cell array   

        Repeat = 0
        Do
            Ndata = 1                                   'number of data points for calculating the propagation velocity
            stretchTime = 0                           'counter of a single segment of the cell array recording 
            Nstretch = 1                             'recording interval of the whole series of responses
            sweepTime = 0                            'time interval for a single sweep
            Do
                If Repeat = 0 Then ApplyDepolRepolStimulations() ' repolarizing stimulus, using either IextK, pOpen_IKATP, or pOpen_IK1 **************

                '********************** numerical integration and plot Vm time course **************************
                If rbEuler.Checked Then          'simple Euler method;  two options for the numerical integration of the cell array
                    Euler()
                Else                                            'Heun method;  two options for the numerical integration of the cell array
                    Heun()
                    SolveMatrix()                       'use the linear solver;  matrix  
                End If

                My.Application.DoEvents()

                '(1) plotTimeCourseVm ******************************************************
                plotTimeCourseVm()                      'panel A

                '(2)   plot 2D_Vo profile **************************
                plot2D_Voprofile()                          'panel B and C

                ''(3)  plot profiles along the Cell array **************************
                plotPlofileVmVoCurrent()                 'Panels D-F

                '(4)  Measure the center of the inward and outward current balance across the external Go ******************
                MeasureOIcenter()

                sweepTime += dt          'proceed with the experimental time
                If sweepTime > Interrupt Then Exit Do
            Loop While sweepTime <= MaxX2 * 100                                             'MaxX2 = 2000 ms

            graph2D_Vo.PlotLine(MinX1, MaxY1 - (startRS - sweepTime), MaxX1, MaxY1 - (startRS - sweepTime), Color.Black, 1)            'beginning time to measure the propagation rate
            graph2D_Vo.PlotLine(MinX1, MaxY1 - (endRS - sweepTime), MaxX1, MaxY1 - (endRS - sweepTime), Color.Black, 1)                'end time to measure the propagation rate
            graph2D_Vo.PlotLine(MinX1, MaxY1 - (measOn - sweepTime), MaxX1, MaxY1 - (measOn - sweepTime), Color.Black, 1)            'beginning time to measure the propagation rate
            graph2D_Vo.PlotLine(MinX1, MaxY1 - (measOff - sweepTime), MaxX1, MaxY1 - (measOff - sweepTime), Color.Black, 1)            'end time to measure the propagation rate
            graph2D_Vo.PlotLine(halfArray, MinY1, halfArray, MaxY1, Color.Black, 1)            'end time to measure the propagation rate

            graph2D_Vo.PlotLine(MinX1, measOn, MaxX1, measOn, Color.Black, 1)            'beginning time to measure the propagation rate
            graph2D_Vo.PlotLine(MinX1, measOff, MaxX1, measOff, Color.Black, 1)            'end time to measure the propagation rate
            graph2D_Vo.PlotLine(MinX1, startRS, MaxX1, startRS, Color.Black, 1)            'beginning time to measure the propagation rate
            graph2D_Vo.PlotLine(MinX1, endRS, MaxX1, endRS, Color.Black, 1)                'end time to measure the propagation rate
            My.Application.DoEvents()                  'now display the result of plots
            Repeat += 1
        Loop While Repeat < 4  '20
        ButtonStart.Visible = True

    End Sub

    Private Sub MeasureOIcenter()
        If sweepTime > measOn And sweepTime < measOff Then          'the onset and offset time for the measurement of rate of propagataion
            For cellNo As Integer = 1 To (halfArray - halfBand) - 1            'left half of the cell array
                valueA = HVC(cellNo).Vo * 1000
                valueB = HVC(cellNo + 1).Vo * 1000
                If valueA * valueB < 0 And (valueA - valueB) < -0.2 Then        'Detect the cross point,    0.2 is used to exclude extra miniature fluctuations
                    leftCross = cellNo + Math.Abs(valueA) / (Math.Abs(valueA) + Math.Abs(valueB))        'cross point in terms of cell No.
                End If
            Next cellNo
            graphprofileVm.PlotLine(leftCross, MinY2, leftCross, MaxY2, Color.Red, 1)              'location of the propagation front
            graphProfileVo.PlotLine(leftCross, MinY4, leftCross, MaxY4, Color.Red, 1)              'location of the propagation front
            graphProfileCurrent.PlotLine(leftCross, MinY5, leftCross, MaxY5, Color.Red, 1)    'location of the propagation front
            'graph2D_Vo.PlotPoint(leftCross, MaxY1 - stretchTime, Color.Black, 1, )              'location of the propagation front

            For cellNo As Integer = (200) + 1 To Nc            'right half of the cell array
                'For cellNo As Integer = (150 + halfBand) + 1 To Nc            'right half of the cell array
                valueA = HVC(cellNo).Vo * 1000
                valueB = HVC(cellNo - 1).Vo * 1000
                If valueA * valueB < 0 And (valueA - valueB) < -0.2 Then        '    'Detect the cross point,    0.2 is used to exclude extra miniature fluctuations
                    rightCross = cellNo - Math.Abs(valueA) / (Math.Abs(valueA) + Math.Abs(valueB))                 'cross point in terms of cell No.
                End If
            Next cellNo
            graphprofileVm.PlotLine(rightCross, MinY2, rightCross, MaxY2, Color.Blue, 1)
            graphProfileVo.PlotLine(rightCross, MinY4, rightCross, MaxY4, Color.Blue, 1)
            graphProfileCurrent.PlotLine(rightCross, MinY5, rightCross, MaxY5, Color.Blue, 1)
            graph2D_Vo.PlotPoint(rightCross, MaxY1 - stretchTime, Color.Black, 1, )

            crossD(Ndata, 0) = stretchTime    'store the stretch time
            crossD(Ndata, 1) = leftCross         'store the leftside front of propagation
            crossD(Ndata, 2) = rightCross      'store the rightside front of propagation

            Dim A As Double = crossD(Ndata, 0)
            Dim B As Double = crossD(Ndata, 1)
            Dim D As Double = crossD(Ndata, 2)
            'graph2D_Vo.PlotPoint(B, MaxY1 - A, Color.Red, 2, 2)  'Lcross point vs time
            'graph2D_Vo.PlotPoint(D, MaxY1 - A, Color.Blue, 2, 2)  'Rcross point vs time

            txtLcross.Text = Format(leftCross, "###0.#")   'location of the front   Cell No.
            txtRcross.Text = Format(rightCross, "###0.#")   'location of the front    Cell No.

            My.Application.DoEvents()                  'now display the result of plots

            '*************** measure the rate of propagation ******************************************
            If Ndata >= 2 Then
                Lrate(Ndata) = (crossD(Ndata, 1) - crossD(Ndata - 1, 1)) / (crossD(Ndata, 0) - crossD(Ndata - 1, 0))    'count / ms     (LcrossR(i) - LcrossR(i-1)) / time interval 
                LsumRate = LsumRate + Lrate(Ndata)

                Rrate(Ndata) = (crossD(Ndata, 2) - crossD(Ndata - 1, 2)) / (crossD(Ndata, 0) - crossD(Ndata - 1, 0))     'count / ms     
                RsumRate = RsumRate + Rrate(Ndata)

                LtxtRate.Text = Format(HVC(10).length_Cell * LsumRate / (Ndata - 1), "#0.######")   'the average rate is now converted to mm/s
                RtxtRate.Text = Format(HVC(10).length_Cell * RsumRate / (Ndata - 1), "#0.######")   'the average rate is now converted to mm/s

                txtNdata.Text = Format(Ndata, "###0.#")
            End If

            Ndata += 1                     'No. of data points
        End If
    End Sub

    Dim oldVm As Double = -90

    Private Sub plotPlofileVmVoCurrent()
        If TtoPlotProfile >= maxTtoPlotProfile Then                               'dt * 20,    plot at an interval of maxTtoplot
            graphprofileVm.Clear()                                                             'Clear profileVm      for each drawing, clear and draw the graph
            graphprofileVm.DrawAxis(IntervalX1, IntervalY2, "", 11)

            graphProfileVo.Clear()                                                              'Clear profile Vo
            graphProfileVo.DrawAxis(IntervalX1, IntervalY4, "", 11)

            graphProfileCurrent.Clear()                                                     'Clear profile Current
            graphProfileCurrent.DrawAxis(IntervalX1, IntervalY5, "", 11)

            'graphIcapIo.Clear()                                                     'Clear profile Current
            'graphIcapIo.DrawAxis(IntervalX1, IntervalY5, "", 11)

            graphProfilepO.Clear()                                                     'Clear profile Current
            graphProfilepO.DrawAxis(IntervalX7, IntervalY8, "", 11)

            '************** plot profile along the cell array ***************************
            cellNo = MinX7              'cellNo = 1 
            Do                                                   'For cellNo As Integer = 1 To Nc
                '(1)  *********** Vm profile ******************************************
                graphprofileVm.PlotLine(cellNo, HVC(cellNo).Vm, cellNo - 1, oldVm, Color.Black, 2)               'panel D
                oldVm = HVC(cellNo).Vm

                '(2) **************Vo profile *******************************************
                If HVC(cellNo).Vo >= 0 Then                                       'plot the profile of Vo along the cell array 
                    'graphProfileVo.PlotLine(cellNo, HVC(cellNo).Vo * 10, cellNo, 0, Color.Red, 2)    'dimension: uV         'Panel E
                    graphProfileVo.PlotLine(cellNo, HVC(cellNo).Vo * 1000, cellNo, 0, Color.Red, 2)    'dimension: uV
                Else
                    'graphProfileVo.PlotLine(cellNo, HVC(cellNo).Vo * 10, cellNo, 0, Color.Blue, 2)   'dimension: uV
                    graphProfileVo.PlotLine(cellNo, HVC(cellNo).Vo * 1000, cellNo, 0, Color.Blue, 2)   'dimension: uV
                End If

                '(3) ************Current profile ***** Panel F  ******** Panel F  *************************************
                '********電流はCmで割ることによってpA/pFで表示する。**********************

                If chkK1.Checked Then graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).IK1 / HVC(cellNo).Cm, Color.Red, 2, 2)
                If chkIKr.Checked Then graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).IKr / HVC(cellNo).Cm, Color.SteelBlue, 2, 2)
                If chkINaL.Checked Then graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).INaL / HVC(cellNo).Cm, Color.Blue, 2, 2)
                If chkICaL.Checked Then graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).ICaL / HVC(cellNo).Cm, Color.Chocolate, 2, 2)
                graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).INaK / HVC(cellNo).Cm, Color.Violet, 2, 2)
                graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).INCX / HVC(cellNo).Cm, Color.Green, 2, 2)
                'graphProfileCurrent.PlotLine(cellNo, (HVC(cellNo).Iion + HVC(cellNo).Icap) / HVC(cellNo).Cm, cellNo - 1, oldIi, Color.DarkGray, 3)      'Io; Iion   total membrane current
                'oldIi = (HVC(cellNo).Iion + HVC(cellNo).Icap) / HVC(cellNo).Cm               'line plot of the Io

                'graphIcapIo.PlotPoint(cellNo, (HVC(cellNo).Icap) / HVC(cellNo).Cm, Color.Purple, 2, 2)      'Icap
                ''graphIcapIo.PlotPoint(cellNo, (HVC(cellNo).Io) / HVC(cellNo).Cm, Color.DarkGray, 2, 2)      'Icap
                'graphIcapIo.PlotLine(cellNo, (HVC(cellNo).Io) / HVC(cellNo).Cm, cellNo - 1, oldIi, Color.DarkGray, 3)      'Io; Iion   total membrane current
                'oldIi = (HVC(cellNo).Io) / HVC(cellNo).Cm               'line plot of the Io

                'If chkK1.Checked Then graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).IK1 / HVC(cellNo).Cm / 100, Color.Red, 2, 2)
                'If chkIKr.Checked Then graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).IKr / HVC(cellNo).Cm / 100, Color.SteelBlue, 2, 2)
                'If chkINaL.Checked Then graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).INaL / HVC(cellNo).Cm / 100, Color.Blue, 2, 2)
                'If chkICaL.Checked Then graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).ICaL / HVC(cellNo).Cm / 100, Color.Chocolate, 2, 2)
                'graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).INaK / HVC(cellNo).Cm / 100, Color.Violet, 2, 2)
                'graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).INCX / HVC(cellNo).Cm / 100, Color.Green, 2, 2)
                'graphProfileCurrent.PlotLine(cellNo, (HVC(cellNo).Iion + HVC(cellNo).Icap) / HVC(cellNo).Cm / 100, cellNo - 1, oldIi, Color.DarkGray, 3)      'Iion   total membrane current
                'oldIi = (HVC(cellNo).Iion + HVC(cellNo).Icap) / HVC(cellNo).Cm / 100              'line plot of the Iaxi

                'If chkbNSC.Checked Then graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).IbNSC / HVC(cellNo).Cm, Color.Red, 2, 2)
                'If chkKpl.Checked Then graphProfileCurrent.PlotPoint(cellNo, HVC(cellNo).IKpl / HVC(cellNo).Cm, Color.DarkGray, 2, 2)

                'graphProfileCurrent.PlotPoint(cellNo, 100 * HVC(cellNo).C_LSM, Color.Black, 1, 1)
                'graphProfileCurrent.PlotPoint(cellNo, 100000 * HVC(cellNo).O_LSM, Color.Green, 1, 1)

                graphProfilepO.PlotPoint(cellNo, HVC(cellNo).O_LSM * 100, Color.Blue, 2, 2)         'panel G
                graphProfilepO.PlotPoint(cellNo, HVC(cellNo).pO_IK1, Color.Red, 2, 2)
                graphProfilepO.PlotPoint(cellNo, HVC(cellNo).pO_IKr, Color.SteelBlue, 2, 2)
                graphProfilepO.PlotPoint(cellNo, HVC(cellNo).pO_ICaL * 10, Color.Chocolate, 2, 2)



                cellNo += 1
            Loop While cellNo < MaxX7                          'Nc
            'Loop While cellNo < Nc

            TtoPlotProfile = 0
        Else
            TtoPlotProfile += dt
        End If

    End Sub

    Private Sub plot2D_Voprofile()
        If stretchTime > MaxY1 Then                  'renew the graph2D_Vo  stretch   when the X-Y graph space is filled
            graph2D_Vo.Clear()
            graph2D_Vo.DrawAxis(IntervalX1, IntervalY1, "", 11)
            '******************* draw holizontal lines *****************
            'If Nstretch = 4 Then
            graph2D_Vo.PlotLine(MinX1, MaxY1 - (startRS - sweepTime), MaxX1, MaxY1 - (startRS - sweepTime), Color.Black, 2)            'beginning time to measure the propagation rate
            graph2D_Vo.PlotLine(MinX1, MaxY1 - (endRS - sweepTime), MaxX1, MaxY1 - (endRS - sweepTime), Color.Black, 2)                'end time to measure the propagation rate
            graph2D_Vo.PlotLine(MinX1, MaxY1 - (measOn - sweepTime), MaxX1, MaxY1 - (measOn - sweepTime), Color.Black, 2)            'beginning time to measure the propagation rate
            graph2D_Vo.PlotLine(MinX1, MaxY1 - (measOff - sweepTime), MaxX1, MaxY1 - (measOff - sweepTime), Color.Black, 2)            'end time to measure the propagation rate
            graph2D_Vo.PlotLine(halfArray, MinY1, halfArray, MaxY1, Color.Black, 1)            'end time to measure the propagation rate
            My.Application.DoEvents()
            stretchTime = 0                                      'renew the stretchTime
        Else
            stretchTime += dt                           'proceed with time
        End If


        If TtoPlot2DVo > maxTtoPlot2DVo Then            'dt * 20
            For cellNo As Integer = 1 To Nc                    'plot the Vo profile using the gradient pen red-white or blue-white colors
                If HVC(cellNo).Vo >= 0 Then                  'positive Vo
                    graph2D_Vo.PlotPoint(cellNo, MaxY1 - stretchTime, gradient3.PenWhiteRed(HVC(cellNo).Vo * 1000, MaxY4 / 2, 0))
                Else                                                           'negative  Vo 
                    graph2D_Vo.PlotPoint(cellNo, MaxY1 - stretchTime, gradient3.PenWhiteBlue(-HVC(cellNo).Vo * 1000, MaxY4 / 2, 0))  'invert the negative sign
                End If
            Next cellNo
            TtoPlot2DVo = 0                                      'reset the counter of plot
        Else
            TtoPlot2DVo = TtoPlot2DVo + dt           'proceed with time
        End If


    End Sub

    Dim oldVmA As Double = -90
    Dim oldVmB As Double = -90
    Dim oldST As Double = 0
    Private Sub plotTimeCourseVm()
        If TtoPlotVm > maxTtoPlotVm Then                 'usually the interval = dt * 20    plot Vm time course
            graphTimeCourseVm.PlotLine(sweepTime, HVC(pointA).Vm, oldST, oldVmA, Color.Blue, 1)      'plot Vm of cell A
            graphTimeCourseVm.PlotLine(sweepTime, HVC(pointB).Vm, oldST, oldVmB, Color.Red, 1)        'plot Vm of cell B
            oldST = sweepTime
            oldVmA = HVC(pointA).Vm
            oldVmB = HVC(pointB).Vm
            TtoPlotVm = 0
        Else
            TtoPlotVm = TtoPlotVm + dt
        End If
    End Sub



    'Private Sub TriggerPulse()
    '    ItestOn = 10
    '    ItestOff = 40
    '    If sweepTime > ItestOn And sweepTime < ItestOff Then               'prepare the electrical stimulus at the begining
    '        Samplitude = 35                 'Evoke the action potential by the depolarizing current
    '    Else
    '        Samplitude = 0                   'no current application
    '    End If
    'End Sub



    Dim oldVo As Double                           'copy of the Vo(n-1)
    Dim ProductVo As Double                   'Vo * oldVo
    Dim invertCellNo As Double                         'Cell No, at the crossing of Vo 0 level
    Dim invertVm As Double                            'Vm, at the crossing of Vo 0 level
    Dim SearchOn As Boolean = False
    Dim valueX As Double
    Dim oldIi As Double

    Private Sub DetermineLRcross()
        Ndata = 0
        If chartTime > 1250 And chartTime < 1600 Then

            'If chartTime >= 1250 And chartTime < 1600 Then
            'If countbalance = 10 Then                                          'record every (2 * dt)
            For cellNo As Integer = 1 To (halfArray - halfBand) - 1            'left half of the cell array
                valueA = HVC(cellNo).Vo * 1000
                valueB = HVC(cellNo + 1).Vo * 1000
                'leftCross = -10
                If valueA * valueB < 0 And (valueA - valueB) < -0.2 Then        'Detect the cross point
                    leftCross = cellNo + Math.Abs(valueA) / (Math.Abs(valueA) + Math.Abs(valueB))                 'cross point in terms of cell No.
                    'Else
                    '    leftCross = -15
                End If
            Next cellNo
            graphprofileVm.PlotLine(leftCross, MinY2, leftCross, MaxY2, Color.Red, 1)
            graphProfileVo.PlotLine(leftCross, MinY4, leftCross, MaxY4, Color.Red, 1)
            graphProfileCurrent.PlotLine(leftCross, MinY5, leftCross, MaxY5, Color.Red, 1)
            graphProfileCurrent.PlotLine(leftCross, MinY5, leftCross, MaxY5, Color.Red, 1)
            'graph2D_Vo.PlotPoint(leftCross, MaxY1 - stretchTime, Color.Black, 1,)

            For cellNo As Integer = (halfArray + halfBand) + 1 To Nc            'right half of the cell array
                valueA = HVC(cellNo).Vo * 1000
                valueB = HVC(cellNo - 1).Vo * 1000
                'rightCross = 210
                If valueA * valueB < 0 And (valueA - valueB) < -0.2 Then        'Detect the cross point
                    rightCross = cellNo - Math.Abs(valueA) / (Math.Abs(valueA) + Math.Abs(valueB))                 'cross point in terms of cell No.
                    'Else
                    '    rightCross = Nc + 15
                End If
            Next cellNo
            graphprofileVm.PlotLine(rightCross, MinY2, rightCross, MaxY2, Color.Blue, 1)
            graphProfileVo.PlotLine(rightCross, MinY4, rightCross, MaxY4, Color.Blue, 1)
            graphProfileCurrent.PlotLine(rightCross, MinY5, rightCross, MaxY5, Color.Blue, 1)
            graph2D_Vo.PlotPoint(rightCross, MaxY1 - stretchTime, Color.Black, 1, )

            crossD(Ndata, 0) = stretchTime    'store the time
            crossD(Ndata, 1) = leftCross      'store the leftside front of propagation
            crossD(Ndata, 2) = rightCross    'store the rightside front of propagation

            'LtxtRate.Text = Format(Data(Ndata, 1), "#0.#")   'the rate is now converted to mm/s
            'RtxtRate.Text = Format(Data(Ndata, 2), "#0.#")   'the rate is now converted to mm/s

            My.Application.DoEvents()

            Ndata = Ndata + 1

        End If

        '*********************** End Analysis ***************************

    End Sub

    Private Sub calculatePropagationRate()

        LsumRate = 0         'accumulater
        RsumRate = 0         'accumulater
        adr = 0
        For i As Long = 1000 To 1500                      'Ndata = 500 ms / dt ms
            Dim A As Double = crossD(i, 0)
            Dim B As Double = crossD(i, 1)
            Dim D As Double = crossD(i, 2)
            'graph2D_Vo.PlotPoint(B, MinY1, Color.Red, 3, 3)  'Lcross point vs time        indicate the progress of data analysis
            'graph2D_Vo.PlotPoint(D, MinY1, Color.Blue, 3, 3)  'Rcross point vs time

            'graph2D_Vo.PlotPoint(Data(i, 1), MaxY1, Color.Red, 1, 1)  'Lcross point vs time
            'graph2D_Vo.PlotPoint(Data(i, 2), MaxY1, Color.Blue, 1, 1)  'Rcross point vs time
            'graph2D_Vo.PlotPoint(B, (MaxY1 - A), Color.Red, 3, 3)      'Lcross point vs time
            'graph2D_Vo.PlotPoint(D, (MaxY1 - A), Color.Blue, 3, 3)     'Rcross point vs time
            'graph2D_Vo.PlotPoint(B, (MaxY1 - B + 1200), Color.Red, 3, 3)      'Lcross point vs time
            'graph2D_Vo.PlotPoint(D, (MaxY1 - D + 1200), Color.Blue, 3, 3)     'Rcross point vs time

            Lrate(i) = (crossD(i, 1) - crossD(i - 1, 1)) / (crossD(i, 0) - crossD(i - 1, 0))    'count / ms     (LcrossR(i) - LcrossR(i-1)) / time interval 
            LsumRate = LsumRate + Lrate(i)

            Rrate(i) = (crossD(i, 2) - crossD(i - 1, 2)) / (crossD(i, 0) - crossD(i - 1, 0))     'count / ms     
            RsumRate = RsumRate + Rrate(i)

            adr = adr + 1           'number of data points
        Next i

        LtxtRate.Text = Format(HVC(10).length_Cell * LsumRate / adr, "#0.######")   'the average rate is now converted to mm/s
        RtxtRate.Text = Format(HVC(10).length_Cell * RsumRate / adr, "#0.######")   'the average rate is now converted to mm/s
        My.Application.DoEvents()

    End Sub



    Dim center As Long = 100    'center of the cell array
    Dim halfBand As Long = 50    '7       'half of the stimulus band
    Dim startRS As Double = 4000 '5000      '1200    start of repolarizing stimulus
    Dim endRS As Double = startRS + 40        'start of repolarizing stimulus

    Private Sub ApplyDepolRepolStimulations()
        'electrical stimulus to start the AP conduction along the single cell array
        ItestOn = 10         '10 msec after start of the record
        ItestOff = 40         '40 ms    after the start of the record
        If sweepTime > ItestOn And sweepTime < ItestOff Then               'prepare the electrical stimulus at the begining
            Samplitude = 35                 'pA/pF,   Evoke the action potential by the depolarizing current
        Else
            Samplitude = 0                   'no current application
        End If

        'the repolarizing stimulus to start the repolarization near the center of the cell array
        If sweepTime >= startRS And sweepTime < endRS Then
            For I As Integer = center - halfBand To center + halfBand       'Cell No. to be stimulated by the repolarizing stimulus
                HVC(I).useIextK = True         'case of using electrical current pulse from an external source
                'HVC(I).useIKATP = True       'case of using ion channels to generate the repolarizing ionic current
                'HVC(I).useIK1 = True            'case of using ion channels to generate the repolarizing ionic current
                'HVC(I).useIKr = True            'case of using ion channels to generate the repolarizing ionic current
                'HVC(I).useINa = True            'case of using ion channels to generate the repolarizing ionic current
                'HVC(I).useICaL = True          'case of using ion channels to generate the repolarizing ionic current
            Next I
        Else
            For I As Integer = center - halfBand To center + halfBand       'Cell No. to be stimulated by the repolarizing stimulus
                HVC(I).useIextK = False
                'HVC(I).useIKATP = False
                'HVC(I).useIK1 = False       'case of using ion channels to generate the repolarizing ionic current
                'HVC(I).useIKr = False            'case of using ion channels to generate the repolarizing ionic current
                'HVC(I).useINa = False       'case of using ion channels to generate the repolarizing ionic current
                'HVC(I).useICaL = False       'case of using ion channels to generate the repolarizing ionic current
            Next I
        End If
    End Sub

    Private Sub ClearGraphprofile()
        graphprofileVm.Clear()
        graphProfileVo.Clear()
        graphProfileCurrent.Clear()
        graphprofileVm.DrawAxis(IntervalX1, IntervalY2, "", 11)
        graphProfileVo.DrawAxis(IntervalX1, IntervalY4, "", 11)
        graphProfileCurrent.DrawAxis(IntervalX1, IntervalY5, "", 11)
    End Sub




    Private Sub Detect0Vo()     'detect the address of zero Vo during the propagation of repolarization at each numerical integration cycle
        'under the condition that all HVC(i)/Vo are available
        Dim i As Integer
        oldVo = 0                      'initial value of (oldVo * HVC(i).Vo) = 0
        invertCellNo = 20
        If HVC(20).Vm < -80 Then             'Resting potential has appeared at the left end of the cell array, 

            i = invertCellNo - 5
            Do
                If oldVo > 0.001 And (oldVo * HVC(i).Vo) < 0 Then      'detect the crossing of Vo profile
                    Dim ratio As Double = HVC(i).Vo / (oldVo - HVC(i).Vo)
                    invertCellNo = i + ratio                                                               'location of invert Vo
                    invertVm = HVC(i).Vm - ratio * (HVC(i - 1).Vm - HVC(i).Vm)    'membrane potential at the OI-center                   

                    graphProfileCurrent.PlotLine(invertCellNo, MinY5, invertCellNo, MaxY5, Color.Red, 1)
                    graphprofileVm.PlotLine(invertCellNo, MinY2, invertCellNo, MaxY2, Color.Red, 1)
                    graphprofileVm.PlotLine(MinX1, invertVm, MaxX1, invertVm, Color.Red, 1)
                    graphProfileVo.PlotLine(invertCellNo, MinY4, invertCellNo, MaxY4, Color.Red, 1)
                    Exit Do
                Else
                    oldVo = HVC(i).Vo
                End If
                i = i + 1
            Loop While i < Nc
        Else
            invertCellNo = 20
        End If

    End Sub



    Dim OIcenter As Double = 100                       'temporary Cell No, at the crossing of Vo 0 level

    'Private Sub DetectZeroVo()     'detect the address of zero Vo during the propagation of repolarization 
    '    '                                        at each numerical integration cycle 
    '    'Dim i As Integer           'cell No.
    '    oldVo = 0                      'initial value of (oldVo * HVC(i).Vo) = 0
    '    'If OIcenter = 0 Then OIcenter = 100 ' temporary  OI_center


    '    If Repeat > 0.5 And HVC(20).Vm < -80 Then             'Resting potential has appeared at the left end No.=20 of the cell array, 

    '        Dim i As Integer = OIcenter - 10                    'start from the cell No 5 cells before the previous invertCellNo
    '        Do
    '            If (oldVo * HVC(i).Vo) < -0.0000000000000001 Then      'detect the crossing of Vo profile
    '                Dim ratio As Double = HVC(i).Vo / (oldVo - HVC(i).Vo)
    '                OIcenter = i + ratio                                                               'location of invert Vo
    '                invertVm = HVC(i).Vm - ratio * (HVC(i - 1).Vm - HVC(i).Vm)    'membrane potential at the OI-center                   

    '                ''***************** print results ******************
    '                graphProfileCurrent.PlotLine(OIcenter, MinY5, OIcenter, MaxY5, Color.Red, 1)   'position of OI-center
    '                graphprofileVm.PlotLine(OIcenter, MinY2, OIcenter, MaxY2, Color.Red, 1)           'vertocal line; indicate the location of OI-center
    '                graphprofileVm.PlotLine(MinX1, invertVm, MaxX1, invertVm, Color.Red, 1)                      'holizontal line; indicate the Vm
    '                graphProfileVo.PlotLine(OIcenter, MinY4, OIcenter, MaxY4, Color.Red, 1)            'vertical line; indicate the position
    '                'My.Application.DoEvents()

    '                'txtOIcenter.Text = Format(OIcenter, "###.0##")
    '                'txtVmOIcenter.Text = Format(invertVm, "###.0##")
    '                '****************** End of print *************************
    '                Exit Do

    '            Else      'shift by one cell No 
    '                oldVo = HVC(i).Vo        'copy the Vo as 'oldVo'
    '                i = i + 1
    '                If i > OIcenter + 20 Then Exit Do 'failed to detect OIcenter
    '            End If
    '        Loop While i < Nc            'fool proof
    '    End If


    '    '****************** measure the rate of propagation of repolarization ******************
    '    'stopW = stopW + dt        'count stopW in msec
    '    'If Repeat > 0.5 And stopW >= 100 Then
    '    '    LastCellNo = OIcenter
    '    '    Velocitymm = (LastCellNo - oldLastCellNo) * (HVC(1).length_Cell / 1000) * (1000 / 100)   'velocity in mm/s
    '    '    txtVelocity.Text = Format(Velocitymm, "##.0###")
    '    '    oldLastCellNo = LastCellNo                        'replace the last cell No.
    '    '    stopW = 0                                       'reset the stop Watch
    '    'Else
    '    'End If
    'End Sub

    Private Sub DefineGraph()
        graph2D_Vo = New Graph2018(pbVo, MinX1, MaxX1, MinY1, MaxY1)
        graphTimeCourseVm = New Graph2018(pbVm, MinX2, MaxX2, MinY2, MaxY2)

        graphprofileVm = New Graph2018(pbprofileVm, MinX7, MaxX7, MinY2, MaxY2)
        graphProfileVo = New Graph2018(pbCellVo, MinX7, MaxX7, MinY4, MaxY4)
        graphProfileCurrent = New Graph2018(pbCI, MinX7, MaxX7, MinY5, MaxY5)

        graphProfilepO = New Graph2018(pbpO, MinX7, MaxX7, MinY8, MaxY8)

        graphVoGradient = New Graph2018(pbVoLine, MinX6, MaxX6, MinY6, MaxY6)                     'Calibration for the color code
    End Sub

    Private Sub clear()
        graphTimeCourseVm.Clear()
        graphprofileVm.Clear()
    End Sub

    Private Sub instanceCell()
        For i As Integer = 0 To Nc           'i should start with 0 for the CSVRW
            HVC(i) = New HuVECII
        Next i
    End Sub

    Private Sub ReadForm()
        Samplitude = CDbl(txtStimulus.Text)        'pA/pF, amplitude of the stimulus current

        Iapply = CDbl(txtIapply.Text)                      'pA/pF,   the repolarizing test current

        Interrupt = CLng(txtInterrupt.Text)              'time to interrupt numerical integration

        pointA = CInt(txtPointA.Text)            'location of a cell for display Vo 
        pointB = CInt(txtPointB.Text)            'location of a cell for display Vo 

        measOn = CLng(txtMeasOn.Text)        'ms, start time to measure the propagation rate
        measOff = CLng(txtMeasOff.Text)        'ms, end time to measure the propagation rate

        For i As Integer = 1 To Nc
            HVC(i).maxGgap = CDbl(txtGgap.Text)                 'nS,  default = 1500 nS,   maximum conductance of the gap junction
            HVC(i).Gi = HVC(i).sfgap * HVC(i).maxGgap        'define the gap junction conductance

            HVC(i).Fext = CDbl(txtFext.Text)                             'mN/mm^2,  external load applied at the end of cell array 外部負荷
            HVC(i).Go = CDbl(txtGo.Text)                                  'ns, conductance of the external series resistor
            'If rbEuler.Checked Then HVC(i).Go = 10000
            txtGo.Text = Format(HVC(1).Go, "###.####")

            'If i > CellBorder Then                                                  'prepare the Epi-type ventricular cells
            HVC(i).scfGNa = CDbl(txtscfINa.Text)                     'scaling factor for GNa magnitude
            HVC(i).sclI1I2 = CDbl(txtscfI1I2.Text)
            HVC(i).scfGKto = CDbl(txtscfIKto.Text)                   'scaling factor for GKto magnitude in the downstream half
            HVC(i).scfGCaL = CDbl(txtscfICaL.Text)                 'scaling factor for GCaL magnitude in the downstream half
            HVC(i).scfGKr = CDbl(txtscfIKr.Text)                       'scaling factor for GKr magnitude in the downstream half
            HVC(i).scfGKs = CDbl(txtscfIKs.Text)                     'scaling factor for GKs magnitude in the downstream half
            HVC(i).scfGK1 = CDbl(txtscfIK1.Text)                     'scaling factor for GK1 magnitude in the downstream half
            HVC(i).ATPt_cyt = CDbl(txtATP.Text)                      'replace by a test [ATP] in the downstream half
            HVC(i).scfGKATP = CDbl(txtscfIKATP.Text)
            HVC(i).scfGNCX = CDbl(txtscfINCX.Text)                  'scaling factor for GNCX magnitude in the downstream half
            HVC(i).scfGNaK = CDbl(txtscfINaK.Text)                    'scaling factor for GNaK magnitude in the downstream half

            HVC(i).I2_LSM = CDbl(txtI2_INaL.Text)
            HVC(i).Is_LSM = CDbl(txtIs_INaL.Text)
        Next i
        'End If


    End Sub

    Private Sub PlotVoColorCode()
        graphVoGradient.DrawAxis(IntervalX6, IntervalY6, "", 11)

        For i As Double = 0 To MaxX6 Step 0.01               'from 0 to 30
            graphVoGradient.PlotLine(i, 1, i, MinY6, gradient2.PenWhiteRed(i, MaxX6 / 2, 0))
        Next i
        For i As Double = MinX6 To 0 Step 0.01               'from -30 to 0
            graphVoGradient.PlotLine(i, 1, i, MinY6, gradient2.PenWhiteBlue(-i, MaxX6 / 2, 0))
        Next i
    End Sub

    Private Sub DrawAxes()

        graphTimeCourseVm.DrawAxis(IntervalX2, IntervalY2, "", 11)            'time course of the sweepTime 

        graph2D_Vo.DrawAxis(IntervalX1, IntervalY1, "", 11)            'profile along the cell array
        'graph2D_Vo.PlotLine(MinX1, measOn, MaxX1, measOn, Color.Black, 1)            'beginning time to measure the propagation rate
        'graph2D_Vo.PlotLine(MinX1, measOff, MaxX1, measOff, Color.Black, 1)            'end time to measure the propagation rate
        'graph2D_Vo.PlotLine(MinX1, startRS, MaxX1, startRS, Color.Black, 1)            'beginning time to measure the propagation rate
        'graph2D_Vo.PlotLine(MinX1, endRS, MaxX1, endRS, Color.Black, 1)                'end time to measure the propagation rate

        graphprofileVm.DrawAxis(IntervalX7, IntervalY2, "", 11)
        graphProfileVo.DrawAxis(IntervalX7, IntervalY4, "", 11)
        graphProfileCurrent.DrawAxis(IntervalX7, IntervalY5, "", 11)
        'graphIcapIo.DrawAxis(IntervalX7, IntervalY5, "", 11)
        graphProfilepO.DrawAxis(IntervalX7, IntervalY8, "", 11)

        graphVoGradient.DrawAxis(IntervalX6, IntervalY6, "", 11)
        My.Application.DoEvents()

    End Sub

    Private Sub ClearAllgraphs()
        graph2D_Vo.Clear()

        graphTimeCourseVm.Clear()
        graphprofileVm.Clear()
        graphProfileVo.Clear()
        graphProfileCurrent.Clear()

        graphVoGradient.Clear()

    End Sub

    Public Iapply As Double

    Private Sub Euler()
        Iclampsub(sweepTime, HVC(0).IgapR)      'Amplitude of stimulus current (HVC(0).IgapKnow)) at P1
        For i As Integer = 1 To Nc - 1
            HVC(i).Igapjunc(HVC(i).IgapR, HVC(i).Gi, HVC(i).Vi, HVC(i + 1).Vi, HVC(i).Ki, HVC(i + 1).Ki)
        Next i
        HVC(Nc).IgapR = 0

        For i = 1 To Nc
            HVC(i).Io = HVC(i - 1).IgapR - HVC(i).IgapR
        Next
        HVC(1).Io = HVC(1).Io - HVC(0).IgapR

        For i As Integer = 1 To Nc
            HVC(i).ModelCell(sweepTime, i, CellBorder, Iapply)
            HVC(i).EulerIntegration(dt)
        Next i
    End Sub

    Private Sub Heun()
        For i As Integer = 1 To Nc
            HVC(i).YtoP1_Y()                              'copy the Euler variables
        Next i

        '>>>>>>>>>> point P1<<<<<<<<<<
        Iclampsub(sweepTime, HVC(0).IgapRnow)
        For i As Integer = 1 To Nc - 1
            HVC(i).Igapjunc(HVC(i).IgapRnow, HVC(i).Gi, HVC(i).Vi, HVC(i + 1).Vi, HVC(i).Ki, HVC(i + 1).Ki)
        Next i

        HVC(Nc).IgapRnow = 0
        For i = 1 To Nc
            HVC(i).Io = HVC(i - 1).IgapRnow - HVC(i).IgapRnow
        Next
        HVC(1).Io = HVC(1).Io - HVC(0).IgapRnow

        For i As Double = 1 To Nc
            HVC(i).ModelCell(sweepTime, i, CellBorder, Iapply)
            HVC(i).copydydt()
            HVC(i).EulerIntegration(dt)
        Next i

        '>>>>>>>>>> point P2 <<<<<<<<<<
        Iclampsub(sweepTime + dt, HVC(0).IgapRaft)
        For i As Integer = 1 To Nc - 1
            HVC(i).Igapjunc(HVC(i).IgapRaft, HVC(i).Gi, HVC(i).Vi, HVC(i + 1).Vi, HVC(i).Ki, HVC(i + 1).Ki)
        Next i
        HVC(Nc).IgapRaft = 0

        For i = 1 To Nc
            HVC(i).Io = HVC(i - 1).IgapRaft - HVC(i).IgapRaft
        Next
        HVC(1).Io = HVC(1).Io - HVC(0).IgapRaft

        For i As Integer = 1 To Nc
            HVC(i).ModelCell(sweepTime, i, CellBorder, Iapply)
            HVC(i).EulerIntegration(dt)
        Next i

        '>>>>>>>>>> average <<<<<<<<<<
        For i = 1 To Nc
            HVC(i).Averagedydt()                    'Heun slope 
            HVC(i).P1_YtoY()
        Next i
        AverageIGi()
        reDetermineIaxdVmdtdKdt()
        'If chkAdt.Checked Then AdjustDt()
        DetermineP4()
    End Sub

    Private Sub Iclampsub(ByVal t As Double, ByRef Iinject As Double)
        Iinject = 0
        If t >= ItestOn And t < ItestOff Then
            Iinject = Samplitude * HVC(1).Cm
        Else
            Iinject = 0
        End If
    End Sub

    Dim meanIaxi As Boolean = True
    Private Sub AverageIGi()         'averaging IgapK over two successive integrations, namely the previous one is called 'IgapKpre'   
        If meanIaxi = True Then
            For i As Integer = 1 To Nc - 1
                If HVC(i).IgapRpre = 0 Then                         'In case of no data available at the beginning of new series
                    HVC(i).IgapRave = HVC(i).IgapRnow
                Else
                    HVC(i).IgapRave = (2 * HVC(i).IgapRpre + 1 * HVC(i).IgapRnow) / 3                 'best so far tested
                End If
                HVC(i).IgapRpre = HVC(i).IgapRave   'preplace IgapKpre by IgapKave for the next  averaging of IgapK
            Next i
        Else           ' In case of no average of three IgapKs is used
            For i As Integer = 1 To Nc - 1
                HVC(i).IgapRave = HVC(i).IgapRnow
            Next i
        End If
        HVC(Nc).IgapRave = 0                            'boundary condition at the right edge at P1
    End Sub

    Private Sub reDetermineIaxdVmdtdKdt()
        HVC(0).IgapRave = HVC(0).IgapRnow                                                                  'copy from the original P1

        For i = 1 To Nc
            HVC(i).Io = HVC(i - 1).IgapRave - HVC(i).IgapRave         'Iaxi at P1 for cells 2~Nc at P1
            'HVC(i).Iaxo = HVC(i).Im                                                                          'Iaxo at P1 for cells 2~Nc at P1
            HVC(i).Vo = HVC(i).Io / HVC(i).Go                                                                  'obtain Vo of individual cells  at P1
            HVC(i).dVmdt = (-HVC(i).P1_Iion + HVC(i).Io) / HVC(i).Cm                                                         'replace dVm/dt at P1　
            HVC(i).dKidt = (-HVC(i).P1_Itot_K + HVC(i).Io) / (HVC(i).Vol_cyt * HVC(i).Faraday)      'replace d[K]/dt at P1
        Next
    End Sub

    Public minDTarray As Double = 0.04            'temporary DT for detecting minimum DT
    Public upperLimitDt As Double = 0.1            '=0.15 'upper limit of Dt
    Public lowerLimitDt As Double = 0.07          'lower limit of Dt
    Private Sub AdjustDt()
        minDTarray = upperLimitDt                    'reset (minDT within a cell array) to the upperlimit of Dt   
        For i = 1 To Nc
            HVC(i).minDTcell = upperLimitDt        'reset minDTcell at the upperlimit
            HVC(i).determineMinDT()                      'determine minDTcell by comparing dVm/dt with the minDTcell
            If HVC(i).minDTcell < minDTarray Then minDTarray = HVC(i).minDTcell 'compare minDTcell between cells
        Next

        dt = Int(1000 * minDTarray) / 1000
        If dt >= upperLimitDt Then dt = upperLimitDt 'constrain by the upper limit of dt
        If dt <= lowerLimitDt Then dt = lowerLimitDt 'constrain by the lower limit of dt
    End Sub

    Private Sub DetermineP4()
        For i = 1 To Nc
            HVC(i).EulerIntegration(dt)                         'all y at P4 are calculated by the numerical integration
        Next i
    End Sub


    Private Sub PlotResultsA()
        graphTimeCourseVm.PlotPoint(sweepTime, HVC(pointA).Vm, Color.Blue, 1, 1)
        graphTimeCourseVm.PlotPoint(sweepTime, HVC(pointB).Vm, Color.Red, 1, 1)

        graphTimeCourseVm.PlotPoint(sweepTime, HVC(0).IgapRnow / 200, Color.Black, 1, 1)

    End Sub

    Private Sub PrepareMatrices()
        'prepare conductance matrix
        Dim buf As Double
        For i = 1 To Nc
            For j = 1 To Nc
                a(i, j) = 0.0
            Next j
        Next i

        a(1, 1) = HVC(1).Go + HVC(1).Gi          'boundary condition at the left edge of the array, Time independent parameters in the electric circuit of the one-dimensional cell array
        a(1, 2) = -HVC(1).Gi
        For i = 2 To Nc - 1
            a(i, i - 1) = -HVC(i).Gi
            a(i, i) = HVC(i).Go + 2.0 * HVC(i).Gi
            a(i, i + 1) = -HVC(i).Gi
        Next i
        a(Nc, Nc - 1) = -HVC(Nc).Gi                        'boundary condition at the right edge of the array
        a(Nc, Nc) = HVC(Nc).Go + HVC(Nc).Gi

        'prepare Eigen matrix for inverse matrix calculation
        For i = 1 To Nc
            For j = 1 To Nc
                If i = j Then
                    ainv(i, j) = 1.0
                Else
                    ainv(i, j) = 0.0
                End If
            Next j
        Next i

        'Gauss elimination method
        For i = 1 To Nc
            buf = 1.0 / a(i, i)
            For j = 1 To Nc
                a(i, j) = a(i, j) * buf
                ainv(i, j) = ainv(i, j) * buf
            Next j
            For j = 1 To Nc
                If i <> j Then
                    buf = a(j, i)
                    For k = 1 To Nc
                        a(j, k) = a(j, k) - a(i, k) * buf
                        ainv(j, k) = ainv(j, k) - ainv(i, k) * buf
                    Next k
                End If
            Next j
        Next i
    End Sub



    Private Sub SolveMatrix()
        '===  Linear solver using the model Vm ============================
        'prepare b vector from Vm (Ax = b), which are time-dependent in the cell model
        b(1) = HVC(1).Gi * (-HVC(1).Vm + HVC(2).Vm)                          'boundary condition at the left edge
        b(Nc) = HVC(Nc).Gi * (HVC(Nc - 1).Vm - HVC(Nc).Vm)             'boundary condition at the right edge
        For i = 2 To Nc - 1
            b(i) = HVC(i).Gi * (HVC(i - 1).Vm - 2 * HVC(i).Vm + HVC(i + 1).Vm)
        Next i

        '********** determine Vo & Vi ************ calculate Vo (x vector by x = A^{-1} b  and Vi
        For i = 1 To Nc
            HVC(i).Vo = 0
            For j = 1 To Nc
                HVC(i).Vo = HVC(i).Vo + ainv(i, j) * b(j)
                HVC(i).Vi = HVC(i).Vm + HVC(i).Vo
            Next j
        Next i
        '*********** End of linear Solver ********************
    End Sub


    Private Sub CreateMatrixcsv()
        Dim Matrix As String = "Matrix.csv"
        Dim FirstTime As Boolean = False
        Dim buf As String

        PrepareMatrices()

        For j = 1 To Nc
            For k = 1 To Nc
                buf = """" & ainv(j, k).ToString() & """"
                If Not FirstTime Then
                    My.Computer.FileSystem.WriteAllText(Matrix, buf & ",", False, System.Text.Encoding.GetEncoding(932)) 'shift_jisで書き込み
                    FirstTime = True
                Else
                    My.Computer.FileSystem.WriteAllText(Matrix, buf & ",", True, System.Text.Encoding.GetEncoding(932)) '2回目以降の書き込みは追記モード(boolean)
                End If
            Next k
            My.Computer.FileSystem.WriteAllText(Matrix, vbCrLf, True, System.Text.Encoding.GetEncoding(932)) '改行文字の挿入
        Next j
    End Sub

    Private Sub ReadMatrixcsv(ByVal data As Object)
        '2018/4/10
        If Not File.Exists("Matrix.csv") Then
            MessageBox.Show("行列ファイルがありません。新たに生成します。")
            CreateMatrixcsv()
        End If

        Dim txtParserma As Microsoft.VisualBasic.FileIO.TextFieldParser = New Microsoft.VisualBasic.FileIO.TextFieldParser("Matrix.csv", System.Text.Encoding.GetEncoding(932))
        txtParserma.TextFieldType = Microsoft.VisualBasic.FileIO.FieldType.Delimited '区切りファイル 
        txtParserma.SetDelimiters(",") '区切り文字を "," に設定
        Dim coulnm_No As Integer = 0 '行列の行(y方向)
        Dim buf As Double = 0
        ' 最後のデータが格納される変数です。
        Dim lastDataset As String() = Nothing

        ' Typeを取得します。
        Dim t As Type = data.GetType()

        ' Publicフィールド名を取得します。
        Dim fields As System.Reflection.FieldInfo() = t.GetFields()

        ' ファイルを最終行まで読み込みます。
        While Not txtParserma.EndOfData

            ' データを1行読み込みます。
            Dim row As String() = txtParserma.ReadFields()

            ' データ数を確認します。
            If row.Length > 1 Then
                lastDataset = row
                coulnm_No = coulnm_No + 1 'ainvに書き込まれる行番号
            End If

            For i As Integer = 0 To row.Length - 1
                If Not row(i) = Nothing Then
                    buf = Double.Parse(row(i))
                    ainv(coulnm_No, i + 1) = buf
                End If
            Next
        End While
        If coulnm_No < Nc Then
            MessageBox.Show("行列ファイルが不適当です。新たに逆行列を生成します。")
            CreateMatrixcsv()
        End If

    End Sub


    Private Sub ButtonErace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonErace.Click
        sweepTime = MaxY1 + 1

    End Sub

    Private Sub ButtonStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Stop
        'ExitDo = True
    End Sub

    Private Sub ButtonEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonEnd.Click
        End
    End Sub

End Class
